<template>
  <label
    for="modal-Apoderado"
    class="btn btn-sm rounded-full btn-secondary text-white text-sm font bold min-w-full"
    v-on:click="inicioModelApoderado()"
    >redactar</label
  >

  <!-- modal Apoderado -->
  <input type="checkbox" id="modal-Apoderado" class="modal-toggle min-w-full" />

  <div class="modal container boder text-center min-w-full">
    <div class="modal-box bg-white relative">
      <section id="todos_los_pasos">
        <article id="paso1ModelApoderado">
          <div id="barra de avanse" style="margin-top: -15px">
            <div class="badge badge-secondary h-">
              &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
            </div>
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
          </div>
          <label for="modal-Apoderado" class="btn btn-sm absolute right-2 top-2"
            >✕</label
          >
          <img
            height="200"
            width="200"
            class="centrar"
            alt="mensaje"
            srcset="https://cdn-icons-png.flaticon.com/512/4144/4144781.png"
          />
          <h3 class="text-lg font-bold">Enviar nuevo mensaje</h3>
          <p class="py-4">Redactar mensaje para docente</p>
          <label
            class="btn btn-sm rounded-full btn-secondary text-white text-sm font w-36 bold"
            v-on:click="
              ($data.id = 'paso1ModelApoderado'),
                elegir_destinatario_ModalApoderado(),
                filtrar()
            "
            >Continuar</label
          >
        </article>

        <article id="paso2ModalApoderado">
          <div id="barra de avanse" style="margin-top: -15px">
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
            <div class="badge badge-secondary">
              &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
            </div>
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
          </div>

          <label
            for="modal-Apoderado"
            class="btn btn-sm absolute right-2 top-2"
            v-on:click="
              ($data.id = 'paso2ModalApoderado'), inicioModelApoderado()
            "
            >✕</label
          >
          <label
            class="btn btn-sm absolute left-2 top-2"
            v-on:click="
              ($data.id = 'paso2ModalApoderado'), inicioModelApoderado()
            "
            ><img
              src="https://cdn-icons-png.flaticon.com/128/566/566098.png"
              alt="back"
              class="w-4 h-4"
          /></label>
          <h3 class="text-lg font-bold">Nuevo mensaje - Docente</h3>

          <br />
          <p class="text-violet-500">
            seleccione <label class="font-medium">un</label> destinatario
          </p>
          <br />
          <div name="remitententes" class="w-72 h-56 centrar">
            <div class="form-control" id="DocenteElegido">
              <div
                class="receptores w-auto max-h-48 min-h-48 scroll scroll-mx-0"
                style="height: 200px"
              >
                <label
                  class="flex flex-initial m-1"
                  v-for="docente in docentes" :key="docente.usuId"
                >
                  <input
                    type="checkbox"
                    class="checkbox checkbox-sm checkbox-secondary mt-1"
                    :value="docente.usuId"
                    v-model="docenteElegido"
                  />
                  <img
                    class="w-7 h-7 rounded-full ml-4 mr-2"
                    src="https://www.meme-arsenal.com/memes/b6a18f0ffd345b22cd219ef0e73ea5fe.jpg"
                    alt="ususario"
                  />
                  <p>{{ docente.nombre }}</p>
                </label>
              </div>
            </div>
          </div>
          <label
            class="btn btn-sm rounded-full btn-secondary text-white text-sm font w-36 bold"
            v-on:click="
              ($data.id = 'paso2ModalApoderado'), validarSoloUnRemitente()
            "
            >Continuar</label
          >
        </article>

        <article id="paso3ModalApoderado">
          <div id="barra de avanse" style="margin-top: -15px">
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
            <div class="badge">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</div>
            <div class="badge badge-secondary">
              &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
            </div>
          </div>
          <label
            for="modal-Apoderado"
            class="btn btn-sm absolute right-2 top-2"
            v-on:click="
              ($data.id = 'paso3ModalApoderado'), inicioModelApoderado()
            "
            >✕</label
          >
          <label
            class="btn btn-sm absolute left-2 top-2"
            v-on:click="
              ($data.id = 'paso3ModalApoderado'),
                elegir_destinatario_ModalApoderado()
            "
            ><img
              src="https://cdn-icons-png.flaticon.com/128/566/566098.png"
              alt="back"
              class="w-4 h-4"
          /></label>
          <h3 class="text-lg font-bold m-2">Nuevo mensaje - Docente</h3>
          <textarea
            class="textarea textarea-primary w-64 h-64 max-h-64"
            placeholder="Escribir mensaje...."
            value
            v-model="cuerpoMensaje"
          ></textarea
          ><br />

          <label
            class="btn btn-sm rounded-full btn-secondary text-white text-sm font bold mt-2"
            v-on:click="notification()"
            >Enviar</label
          >
        </article>

        <article id="paso_finalModalApoderado">
          <label
            for="modal-Apoderado"
            class="btn btn-sm absolute right-2 top-2"
            v-on:click="
              ($data.id = 'paso_finalModalApoderado'), inicioModelApoderado()
            "
            >✕</label
          >
          <img
            height="130"
            class="centrar"
            alt="notificacion"
            srcset="https://i.postimg.cc/DzdVpXSs/image-12.png"
          />
          <h3 class="text-lg font-bold">¡Mensaje enviado con éxito!</h3>
          <label
            for="modal-Apoderado"
            class="btn btn-sm adsolute btn-secondary text-white text-sm font w-36 rounded-full mt-2 bold"
            v-on:click="
              ($data.id = 'paso_finalModalApoderado'),
                inicioModelApoderado(),
                recargar()
            "
            >cerrar</label
          >
        </article>
      </section>
    </div>
  </div>

  <!-- modal Apoderado-->
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      docentes: null,
      docenteElegido: [],
      id: null,
      cuerpoMensaje: "",
      form: {
        username: "apoderado1",
        password: "password1",
      },
    };
  },
  props: {
    usuario: null,
  },
  async mounted() {
    await axios
      .get(
        "/administracionCursos/docenteAsociadosAlumno/" + this.usuario.usuId,
        {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        }
      )
      .then((response) => {
        this.docentes = response.data;
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    filtrar() {
      var largo = 0;
      var noRepetidos = [];
      var miArryId = [];
      var myArr = this.$data.docentes;
      for (var i = 0; i < myArr.length; i++) {
        miArryId[i] = myArr[i].usuId;
      }

      largo = [...new Set(miArryId)].length;
      miArryId = [...new Set(miArryId)];

      for (let j = 0; j < myArr.length; j++) {
        for (let index = 0; index < miArryId.length; index++) {
          if (miArryId[index] == [myArr[j].usuId]) {
            noRepetidos.push(myArr[j]);
            miArryId[index] = "";
          }
        }
      }
      this.$data.docentes = noRepetidos;
    },
    validarSoloUnRemitente() {
      if (
        this.$data.docenteElegido.length > 1 ||
        this.$data.docenteElegido.length == 0
      ) {
        alert("advertencia, solo precionar un docente para enviar mensaje");
      } else {
        this.redactar_mensaje_apoderadoModal();
      }
    },
    ocultar() {
      try {
        document.getElementById(this.$data.id).style.display = "none";
      } catch (error) {
        console.log(error);
      }
    },
    inicioModelApoderado() {
      this.cuerpoMensaje = "";
      this.$data.docenteElegido = [];
      document.getElementById("paso1ModelApoderado").style.display = "block";
      this.ocultar();
    },
    elegir_destinatario_ModalApoderado() {
      document.getElementById("paso2ModalApoderado").style.display = "block";
      this.ocultar();
    },
    redactar_mensaje_apoderadoModal() {
      document.getElementById("paso3ModalApoderado").style.display = "block";
      this.ocultar();
    },
    notification() {
      if (this.$data.cuerpoMensaje != "") {
        this.enviarMensaje();
        this.$data.id = "paso3ModalApoderado";
        document.getElementById("paso_finalModalApoderado").style.display =
          "block";
        this.ocultar();
      } else {
        alert(
          "el cuerpo del mensaje esta vacio, \nfavor de redactar el mensaje y luego enviar........"
        );
      }
    },
    recargar() {
      location.reload();
    },
    async enviarMensaje() {
      if (this.text != "") {
        await axios
          .post(
            "mensaje/nuevoMensaje?cuerpo=" +
              this.$data.cuerpoMensaje +
              "&emisor=" +
              this.usuario.usuId +
              "&receptor=" +
              this.$data.docenteElegido,
            this.form,
            {
              headers: {
                Authorization: localStorage.getItem("auth"),
              },
            }
          )
          .then((response2) => {})
          .catch((error) => {
            console.log(error);
          });
      }
    },
  },
  computed: {},
};
</script>

<style scoped>
.scrollbar::-webkit-scrollbar {
  width: 15px;
  height: 20px;
}

.scrollbar::-webkit-scrollbar-track {
  border-radius: 100vh;
  background: white;
}

.scrollbar::-webkit-scrollbar-thumb {
  background: #a181e2;
  border-radius: 100vh;
  border: 3px solid white;
}

.scrollbar::-webkit-scrollbar-thumb:hover {
  background: #8565c5;
}

.centrar {
  margin: auto;
  display: block;
}

article {
  display: none;
}
.badge {
  height: 7px;
}

.badge.filtro {
  height: 20px;
  background-color: rgb(173, 173, 173);
  border-radius: 5px;
}

.receptores {
  border-top-width: 2px;
  border-top-color: rgb(124 58 237);
  background-color: white;
}

.scroll {
  overflow-y: scroll;
  scroll-margin-top: 1px;
  scroll-margin-bottom: 1px;
}
</style>
